#!/usr/bin/python
# coding=UTF-8
import xml.sax
import os
import sys

programmes = ["J-music", "J-Top", "Indies", "101%", "Intro de jeu", "Superplay", "Chez Marcus","Gameclip","écrans.fr","J'irai loler sur vos tombes","Oscillations","Temps Réel"]


class XMLTVNolifeHandler(xml.sax.ContentHandler):
    
    def __init__(self, fichier):

        self.fichier = open(fichier,"w")
        self.inProgram = False
        self.inTitle = False
        self.contentProgram = ""
        self.lastContentProgram = ""
        self.TitleProgram = ""
        self.lastTitleProgram = ""

    
    
    def getTagElement(self,name, element):
        
        content = ""
        for id,value in element.items():
            content += " " + id + "=\"" + value + "\""
        content =  "<" + name + content + ">"
        return content
    
    
    def startElement(self, name, attrs):
        
        if (name == "programme"):
            self.inProgram = True
            self.contentProgram = ""
        
        if (not(self.inProgram)):
            self.fichier.write(self.getTagElement(name, attrs))
        else:
            if (name == "title"):
                self.inTitle = True
                self.TitleProgram = ""
            else:
                self.contentProgram +=  self.getTagElement(name, attrs)


    def characters(self, ch):
        
        if (not(self.inProgram)):
            self.fichier.write(self.replace(ch))
        else:
            if (self.inTitle):
                self.TitleProgram += self.replace(ch)
            else:
                self.contentProgram += self.replace(ch)
    
    def replace(self, ch1):
        if ch1=="<":
            return "&lt;"
        elif ch1==">":
            return "&gt;"
        elif ch1=="&":
            return "&amp;"
        elif ch1=="\"":
            return "&quot;"
        elif ch1=="\'":
            return "&apos;"
        else:
            return ch1
    

    def endElement(self, name):

        if (not(self.inProgram)):
            self.fichier.write("</" + name + ">" )

        else:
            if (name == "programme"):            
                
                if (self.TitleProgram != self.lastTitleProgram):

                    if (self.lastContentProgram != ""):
                        self.lastContentProgram += "<title>" + self.lastTitleProgram + "</title>\n"
                        self.lastContentProgram += "</" + name + ">\n"
                        self.fichier.write(self.lastContentProgram)
                    self.lastContentProgram = self.contentProgram
                    self.lastTitleProgram = self.TitleProgram
                    
                else:
                    lastStopIndex=self.lastContentProgram.find("stop=")
                    lastChannelIndex=self.lastContentProgram.find(" channel=")
                    stopIndex=self.contentProgram.find("stop=")
                    channelIndex=self.contentProgram.find(" channel=")
                    self.lastContentProgram = self.lastContentProgram[:lastStopIndex] + self.contentProgram[stopIndex:channelIndex] + self.lastContentProgram[lastChannelIndex:]     

            
            elif (name == "title"):
                self.inTitle=False
                for specTitle in programmes:
                    if (self.TitleProgram.startswith(specTitle)):
                        self.TitleProgram = specTitle
                        break
            
            else:
                self.contentProgram += "</" + name + ">"
        
        if (name == "tv"):
            self.lastContentProgram += "<title>" + self.lastTitleProgram + "</title>\n"
            self.lastContentProgram += "</programme>\n"
            self.fichier.write(self.lastContentProgram)
            self.fichier.write("</tv>")
            self.fichier.close()
        


parser = xml.sax.make_parser()
handler = XMLTVNolifeHandler("xmltv-nolife.xml")
parser.setContentHandler(handler)
parser.parse(open("noair-xmltv.xml","r"))