<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:date="http://exslt.org/dates-and-times"
  extension-element-prefixes="date"
  >

   <xsl:output method="xml"
      indent="yes"
      encoding="UTF-8"
      omit-xml-declaration="no"/>
   <xsl:template match="/">
      <xsl:comment> Programme de NoLife en xmltv </xsl:comment>
      <tv source-info-name="NoAir" generator-info-name="NoAirToXMLTV" source-info-url="http://www.nolife-tv.com/noair/noair.xml">
      <channel id="nolife.fr">
         <display-name>NoLife</display-name>
      </channel>
      <xsl:for-each select="/NoAir/slot">
         <xsl:if test="position() != last()">
            <xsl:element name="programme">
               <xsl:attribute name="start">
                  <xsl:value-of select="concat(translate(@date,'/: ',''), ' +0100')" />
               </xsl:attribute>
               <xsl:attribute name="stop">
    <!--- 
la date de stop correspond à l'attribut date du prochain element.
     -->
                  <xsl:value-of select="concat(translate(following-sibling::*[position()=1]/@date,'/: ',''), ' +0100')" />
               </xsl:attribute>
               <xsl:attribute name="channel">nolife.fr</xsl:attribute>
               <xsl:element name="title">
                  <xsl:value-of select="concat(@title,' ',@sub-title)" />
               </xsl:element>
               <xsl:element name="desc">
                  <xsl:value-of select="concat(@description,' ', @detail)" />
               </xsl:element>
               <xsl:element name="category">
                  <xsl:choose>
                     <xsl:when test="@color = 'red'">Musique</xsl:when>
                     <xsl:when test="@color = 'blue'">Magazine</xsl:when>
                     <xsl:when test="@color = 'yellow'">Musique</xsl:when>
                     <xsl:when test="@color = 'white'">Information</xsl:when>
                     <xsl:when test="@color = 'green'">Magazine</xsl:when>
                     <xsl:when test="@color = 'pink'">Magazine</xsl:when>
                     <xsl:when test="@color = 'purple'">Série</xsl:when>
                  </xsl:choose>
               </xsl:element>
            </xsl:element>
         </xsl:if>
      </xsl:for-each>
      </tv>
   </xsl:template>
</xsl:stylesheet>